unit ufrmMainShop;

interface

uses
  Windows
  , Messages
  , SysUtils
  , Classes
  , Graphics
  , Controls
  , Forms
  , Dialogs
  , uToyShop
  , StdCtrls, ExtCtrls
  ;

type
  TfrmMainShop = class(TForm)
    lstToys: TListBox;
    cmdSet1: TButton;
    cmdSet2: TButton;
    cmdSet3: TButton;
    cmdPlay: TButton;
    cmdTidy: TButton;
    cmdGive: TButton;
    rgrpToyTypes: TRadioGroup;
    cmdClose: TButton;
    procedure cmdSet1Click(Sender: TObject);
    procedure cmdSet2Click(Sender: TObject);
    procedure cmdSet3Click(Sender: TObject);
    procedure cmdPlayClick(Sender: TObject);
    procedure cmdTidyClick(Sender: TObject);
    procedure cmdGiveClick(Sender: TObject);
    procedure rgrpToyTypesClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cmdCloseClick(Sender: TObject);
  private
    { Private declarations }
    FShop: TToyShop;
    FToyType: integer;

  public
    { Public declarations }
  end;

var
  frmMainShop: TfrmMainShop;

implementation

uses
  uToy
  , uBricksFactory
  , uDollsFactory
  ;

{$R *.DFM}

procedure TfrmMainShop.cmdSet1Click(Sender: TObject);
var
  nItem: integer;
  sToyType: string;
begin
  // Get set no. 1
  if Assigned(FShop) and
     (rgrpToyTypes.ItemIndex > -1) then
  begin
    sToyType := rgrpToyTypes.Items[rgrpToyTypes.ItemIndex];
    nItem := lstToys.Items.AddObject('', FShop.GetSet1(sToyType));
    lstToys.Items.Strings[nItem] := TToy(lstToys.Items.Objects[nItem]).Name;
  end;
end;

procedure TfrmMainShop.cmdSet2Click(Sender: TObject);
var
  nItem: integer;
  sToyType: string;
begin
  // Get set no. 2
  if Assigned(FShop) and
     (rgrpToyTypes.ItemIndex > -1) then
  begin
    sToyType := rgrpToyTypes.Items[rgrpToyTypes.ItemIndex];
    nItem := lstToys.Items.AddObject('', FShop.GetSet2(sToyType));
    lstToys.Items.Strings[nItem] := TToy(lstToys.Items.Objects[nItem]).Name;
  end;
end;

procedure TfrmMainShop.cmdSet3Click(Sender: TObject);
var
  nItem: integer;
  sToyType: string;
begin
  // Get set no. 3
  if Assigned(FShop) and
     (rgrpToyTypes.ItemIndex > -1) then
  begin
    sToyType := rgrpToyTypes.Items[rgrpToyTypes.ItemIndex];
    nItem := lstToys.Items.AddObject('', FShop.GetSet3(sToyType));
    lstToys.Items.Strings[nItem] := TToy(lstToys.Items.Objects[nItem]).Name;
  end;
end;

procedure TfrmMainShop.cmdPlayClick(Sender: TObject);
begin
  // Play with the selected toy set
  if (lstToys.ItemIndex > -1) then
    TToy(lstToys.Items.Objects[lstToys.ItemIndex]).PlayWithMe;
end;

procedure TfrmMainShop.cmdTidyClick(Sender: TObject);
begin
  // Tidy the selected toy set away
  if (lstToys.ItemIndex > -1) then
    TToy(lstToys.Items.Objects[lstToys.ItemIndex]).TidyMeAway;
end;

procedure TfrmMainShop.cmdGiveClick(Sender: TObject);
begin
  // Give the selected toy set away to another child
  if (lstToys.ItemIndex > -1) then
  begin
    TToy(lstToys.Items.Objects[lstToys.ItemIndex]).Free;
    lstToys.Items.Delete(lstToys.ItemIndex);
  end;
end;

procedure TfrmMainShop.rgrpToyTypesClick(Sender: TObject);
begin
  try
    if (FToyType <> rgrpToyTypes.ItemIndex) and
       (lstToys.Items.Count = 0) then
      FToyType := rgrpToyTypes.ItemIndex
    else
      raise Exception.Create('You must give away all your toys before you can have one of a different type');
  except
    rgrpToyTypes.ItemIndex := FToyType;
    raise;
  end;
end;

procedure TfrmMainShop.FormCreate(Sender: TObject);
begin
  FToyType := -1;
  // Create a toy shop and load the "catalogue" into the toy types radio group
  FShop := TToyShop.Create;
  rgrpToyTypes.Items.Clear;
  FShop.GetToyTypes(rgrpToyTypes.Items);
end;

procedure TfrmMainShop.cmdCloseClick(Sender: TObject);
begin
  Self.Close;
end;

end.
