unit uToyFactory;

interface

uses
  uToy
  , classes                     // for TPersistent & TList
  ;

type

  TToyFactory = class(TPersistent)
  private

  protected

    function Borrow: TToy; virtual; abstract;

  public

    procedure Return(Toy: TToy); virtual; abstract;

    constructor Create; virtual; abstract;

    function GetSet1: TToy; virtual; abstract;
    function GetSet2: TToy; virtual; abstract;
    function GetSet3: TToy; virtual; abstract;

  published

  end;

procedure RegisterFactory(ToyType, ClassName: string);

implementation

uses
  uToyLibrary
  ;

{ TToyFactory }

procedure RegisterFactory(ToyType, ClassName: string);
var
  tsTemp: TToyLibrary;
begin
  tsTemp := TToyLibrary.Create;           // Get a reference to the toy library
  tsTemp.Register(ToyType, ClassName);
end;

end.
